this.name					= "trackerCam_cameraScript";
this.author					= "Thargoid, with inspiration from code by Cim";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Ship script for tracking camera";
this.version				= "1.02";

this.shipSpawned = function()
	{
	if(player.ship && player.ship.isValid)	{ this.ship.orientation = player.ship.orientation; }
	}
	
this.shipDied = function()
	{ 
	if(this.$callback) { removeFrameCallback(this.$callback); }
	}

this.$toggleCamera = function()
	{
	if(this.$camActive === undefined || this.$camActive === "no")
		{ this.$activateCamera(); }
	else
		{ this.$deactivateCamera(); }
	}
	
this.$deactivateCamera = function() 
	{
	this.$camActive = "no";
	this.$resetView();
	removeFrameCallback(this.$callback);
	delete this.$callback;
	player.consoleMessage("Tracking camera link deactivated");
	}

this.$activateCamera = function() 
	{
	this.$callback = addFrameCallback(this.$rotateCamera.bind(this));
	this.$camActive = "yes";
	player.consoleMessage("Tracking camera linked to custom view screen");
	}	
	
this.$resetView = function() 
	{ 
	if(player.ship.viewDirection === "VIEW_CUSTOM")
		{ player.ship.resetCustomView(); }	
	}
	
this.$rotateCamera = function() 
	{
	if(!this.ship || !this.ship.isValid || !player.ship || !player.ship.isValid) 
		{ 
		this.$resetView();
		return; 
		}

	if(this.ship.position.distanceTo(player.ship.position) > 25600)
		{ 
		this.ship.remove();
		this.$resetView();
		return; 
		}
	
	// re-orient the camera entity to always point at the player ship (for visual reasons)
	var targetVector = player.ship.position.subtract(this.ship.position).direction();
	var angle = this.ship.heading.angleTo(targetVector);
	var cross = this.ship.heading.cross(targetVector).direction();
	this.ship.orientation = this.ship.orientation.rotate(cross,-angle);	

	var transpose = player.ship.orientation.conjugate();
	
	var pos = this.ship.position.add(this.ship.vectorForward.multiply(15));
	pos = pos.subtract(player.ship.position); 
	// vector from the player ship to the viewpoint, 15m in front of the camera
	
	var posipcc = pos.rotateBy(transpose);
	var quat = this.ship.orientation.multiply(transpose);
	
	if(player.ship.viewDirection === "VIEW_CUSTOM")
		{ player.ship.setCustomView(posipcc, quat, "FORWARD"); }
	}	